<?php
/**
 * @copyright	Copyright (C) 2013 Alex Chartier All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die('Restricted access'); 
jimport('joomla.plugin.plugin'); 
/**
 * Newpost Kunena Plugin
 *
 * @package		Joomla.Plugin
 * @subpackage	Kunena.Newpost
 * @since   2.5
 */

class plgKunenaNewpost extends JPlugin 
{ 
	/**
	 * Newpost after save message method
	 * Message is passed by reference, but after the save, so no changes will be saved.
	 * Method is called right after the Message is saved
	 *
	 * @param	string		$context	The context of the message passed to the plugin (added in 1.6)
	 * @param	object		$table		A Table object containing the message
	 * @param	bool		$isNew		If the message has just been created
	 * @since	2.5
	 */
    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }


	public function convertBodyImage_Href($message_body)
	{
		$tobereplaced = array();	$replacedby=array();
		$uri = JFactory::getURI();	$site_url = $uri->toString(array('scheme','host', 'port'));		
		
		@preg_match_all('/<a[^>]+>/i',$message_body, $matches);
		if($matches)
		{
			foreach( $matches[0] as $matche)
			{
				preg_match_all('/(href)=("[^"]*")/i',$matche, $href);			
				if(isset($href[2][0]))
				{
					if($href[2][0]!='')
					{
						$a_href=str_replace(array('"',"'"),array('',''),$href[2][0]);
						if(strtolower(substr($a_href,0,4))=='www.')
						{
							$tobereplaced[]=$href[0][0];							
							$url ='http://'.$a_href;
							$replacedby[]='href="'.$url.'"';
						}	
						elseif(strtolower(substr($a_href,0,7))!='http://' AND strtolower(substr($a_href,0,8))!='https://')
						{
							$tobereplaced[]=$href[0][0];	
							if(trim($a_href)=='index.php' OR trim($a_href)=='/')
								$url =$uri->root();					
							else
								$url =$site_url . JRoute::_($a_href);		
								
							$replacedby[]='href="'.$url.'"';
						}					
					}
				}
			}
		}
		@preg_match_all('/<img[^>]+>/i',$message_body, $matches);
		if($matches)
		{
			foreach( $matches[0] as $matche)
			{
				preg_match_all('/(src)=("[^"]*")/i',$matche, $src);			
				if(isset($src[2][0]))
				{
					if($src[2][0]!='')
					{
						$img_src=str_replace(array('"',"'"),array('',''),$src[2][0]);
						if(strtolower(substr($img_src,0,7))!='http://' AND strtolower(substr($img_src,0,8))!='https://')
						{
							$tobereplaced[]=$src[0][0];
							
							$url = str_replace(' ','%20',$uri->root().$img_src);
							$replacedby[]='src="'.$url.'"';
						}					
					}
				}
			}
		}		

		return str_replace($tobereplaced,$replacedby,$message_body);
	}	
	public function onKunenaAfterSave($context, $data, $isNew) { 
	  
		if ( $isNew == FALSE )
		  	return true;	// No message if just editing an existing post
		
		// Get the plugin parameters
		$dbTableName = $this->params->get('tablename', '');
		$emailFrom = $this->params->get('emailfrom', '');
		$emailName = $this->params->get('emailname', '');
		
		if (empty($dbTableName)) {
			return true;	// plugin is probably not initialized
		}

	  	$db = &JFactory::getDbo(); 
		
		// Make sure the selected table has the proper schema
		$columns = array("kunena_cat", "msg_type", "subject", "msg_body");
		$db->setQuery("SHOW COLUMNS FROM $dbTableName");
		$rows = $db->loadColumn();
		foreach ( $columns as $column ) {
			if (in_array($column,$rows)===false)
				return; // column does not exist, wrong db table
		}	
		// Use the default configuration values if the email params are not set
		$config = JFactory::getConfig();
		if ( empty($emailFrom))
			$emailFrom = $config->getValue( 'config.mailfrom' );
		if ( empty($emailName))
			$emailName = $config->getValue( 'config.fromname' );

		$user	= JFactory::getUser();
  		$catId  = $data->category_id;
		$postSubject = $data->subject;
		$isReply = property_exists($data, "parent") == TRUE ? 2 : 1;

	    /* Get the name of the posted category */
	    $query	= $db->getQuery(true);
		$query
	    	->select('name')
	    	->from('#__kunena_categories')
	    	->where('id="' . $catId . '"');
	    $db->setQuery($query);
	    $catName = $db->loadResult();
		
		// Message substitutions
		$finds = array("{name}", "{email}", "{category}", "{date}", "{subject}");
		$replaces = array( $user->name, $user->email, $catName, date("F j, Y, g:i a"), $postSubject);
		
		//Get the message
		$query = $db->getQuery(true);
		$query	
			->select('subject')
			->select('msg_body')
			->from("$dbTableName")
			->where('kunena_cat="' . $catId . '"')
			->where('msg_type="' . $isReply . '"');
		$db->setQuery($query);
		$email = $db->loadObject();
		
		if ( empty($email))
			return true;	// there is no special email for this category and/or type
		$subject = str_replace($finds, $replaces, $email->subject);
		$body = plgKunenaNewpost::convertBodyImage_Href(str_replace($finds, $replaces, $email->msg_body));
	
		$mailer = JFactory::getMailer();
		// Build email message format.
		$mailer->setSender(array($emailFrom, $emailName));
		$mailer->setSubject($subject);
		$mailer->setBody($body);
		$mailer->IsHTML(1);
		$mailer->addRecipient($user->email, $user->name);
			
		// Send the Mail
		$rs	= $mailer->Send();
		// Check for an error
		if ($rs instanceof Exception) {
		//    $app->setUserState('com_users.display.mail.data', $data);
			JError::raiseError(0, $rs->getError());
			return false;
		} elseif (empty($rs)) {
		//    $app->setUserState('com_users.display.mail.data', $data);
			JError::raiseError(0, JText::_('COM_USERS_MAIL_THE_MAIL_COULD_NOT_BE_SENT'));
			return false;
		}
		return true;
	} 
}

?>