<?php
/**
 * @copyright	Copyright (C) 2013 Alex Chartier All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die('Restricted access'); 

jimport('joomla.html.html');
jimport('joomla.form.formfield');//import the necessary class definition for formfield


/**
 * Supports an HTML select list of articles
 * @since 1.6
 */
class JFormFieldDbTables extends JFormField
{
	 /**
	 * The form field type.
	 *
	 * @var string
	 * @since 1.6
	 */
	 public $type = 'dbtables'; //the form field type

	 /**
	 * Method to get content articles
	 *
	 * @return array The field option objects.
	 * @since 1.6
	 */
	 public function getInput()
	 { 
		 // Initialize variables.
		 $options = array();
		 $attr = '';
		 if ( !isset($this->value) || strlen($this->value) == 0 ) {
		 	$this->value = "0";
		 }

		 // Initialize some field attributes.
		 $attr .= $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';

		 // To avoid user's confusion, readonly="true" should imply disabled="true".
		 if ( (string) $this->element['readonly'] == 'true' || (string) $this->element['disabled'] == 'true') {
		 	$attr .= ' disabled="disabled"';
		 }

		 $attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';
		 $attr .= $this->multiple ? ' multiple="multiple"' : '';

		 // Initialize JavaScript field attributes.
		 $attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';

		 //now get to the business of finding the tables
		 
		 $db = &JFactory::getDBO();
		 $tables = $db->getTableList();
		 
		 $options = array();
		 $options[] = JHTML::_('select.option', 0, 'Please select' );

		 foreach ($tables as $table) {
		 	$options[] = JHTML::_('select.option', $table, JTEXT::_($table) );
		 }

		 return JHTML::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $this->value );
	}
}	